#ifndef MBEDTLS_EDDYSTONE_CONFIG_H
#define MBEDTLS_EDDYSTONE_CONFIG_H

/* System support */
//#define MBEDTLS_HAVE_ASM
#undef  MBEDTLS_HAVE_ASM
#define MBEDTLS_HAVE_TIME
#undef  MBEDTLS_HAVE_TIME_DATE

// #define MBEDTLS_CIPHER_MODE_CBC
#undef  MBEDTLS_CIPHER_PADDING_PKCS7
#undef  MBEDTLS_REMOVE_ARC4_CIPHERSUITES
#define MBEDTLS_CIPHER_MODE_CTR

/* mbed TLS feature support */
#define MBEDTLS_ECP_DP_SECP256R1_ENABLED
#undef  MBEDTLS_ECP_DP_SECP384R1_ENABLED
#define MBEDTLS_ECP_DP_CURVE25519_ENABLED

#undef  MBEDTLS_ECP_NIST_OPTIM
#undef  MBEDTLS_ECDSA_DETERMINISTIC
#undef  MBEDTLS_KEY_EXCHANGE_PSK_ENABLED
#undef  MBEDTLS_KEY_EXCHANGE_ECDHE_PSK_ENABLED
#undef  MBEDTLS_KEY_EXCHANGE_ECDHE_RSA_ENABLED
#undef  MBEDTLS_KEY_EXCHANGE_ECDHE_ECDSA_ENABLED
#undef  MBEDTLS_ERROR_STRERROR_DUMMY
#undef  MBEDTLS_PK_RSA_ALT_SUPPORT
#undef  MBEDTLS_PKCS1_V15
#undef  MBEDTLS_PKCS1_V21
#undef  MBEDTLS_SELF_TEST
#undef  MBEDTLS_SSL_ALL_ALERT_MESSAGES
#undef  MBEDTLS_SSL_ENCRYPT_THEN_MAC
#undef  MBEDTLS_SSL_EXTENDED_MASTER_SECRET
#undef  MBEDTLS_SSL_RENEGOTIATION
#undef  MBEDTLS_SSL_MAX_FRAGMENT_LENGTH
#undef  MBEDTLS_SSL_PROTO_TLS1_2
#undef  MBEDTLS_SSL_PROTO_DTLS
#undef  MBEDTLS_SSL_ALPN
#undef  MBEDTLS_SSL_DTLS_ANTI_REPLAY
#undef  MBEDTLS_SSL_DTLS_HELLO_VERIFY
#undef  MBEDTLS_SSL_DTLS_CLIENT_PORT_REUSE
#undef  MBEDTLS_SSL_DTLS_BADMAC_LIMIT
#undef  MBEDTLS_SSL_SESSION_TICKETS
#undef  MBEDTLS_SSL_EXPORT_KEYS
#undef  MBEDTLS_SSL_SESSION_TICKETS
#undef  MBEDTLS_SSL_EXPORT_KEYS
#undef  MBEDTLS_SSL_SERVER_NAME_INDICATION
#undef  MBEDTLS_VERSION_FEATURES
#undef  MBEDTLS_X509_CHECK_KEY_USAGE
#undef  MBEDTLS_X509_CHECK_EXTENDED_KEY_USAGE

/* mbed TLS modules */
#define MBEDTLS_AES_C
#undef  MBEDTLS_ASN1_PARSE_C
#undef  MBEDTLS_ASN1_WRITE_C
#undef  MBEDTLS_BASE64_C
#define MBEDTLS_BIGNUM_C
#undef  MBEDTLS_CCM_C
#undef  MBEDTLS_CERTS_C
#undef  MBEDTLS_CIPHER_C
#define MBEDTLS_CTR_DRBG_C
#undef  MBEDTLS_DEBUG_C
#define MBEDTLS_ECDH_C
#undef  MBEDTLS_ECDSA_C
#define MBEDTLS_ECP_C
#define MBEDTLS_ENTROPY_C
#undef  MBEDTLS_ERROR_C
#undef  MBEDTLS_GCM_C
#undef  MBEDTLS_HMAC_DRBG_C
#define MBEDTLS_MD_C
#undef  MBEDTLS_OID_C
#undef  MBEDTLS_PEM_PARSE_C
#undef  MBEDTLS_PK_C
#undef  MBEDTLS_PK_PARSE_C
#undef  MBEDTLS_PK_WRITE_C
#undef  MBEDTLS_PLATFORM_C
#undef  MBEDTLS_RSA_C
#define MBEDTLS_SHA256_C
#undef  MBEDTLS_SHA512_C
#undef  MBEDTLS_SSL_CACHE_C
#undef  MBEDTLS_SSL_COOKIE_C
#undef  MBEDTLS_SSL_TICKET_C
#undef  MBEDTLS_SSL_CLI_C
#undef  MBEDTLS_SSL_SRV_C
#undef  MBEDTLS_SSL_TLS_C
#undef  MBEDTLS_VERSION_C
#undef  MBEDTLS_X509_USE_C
#undef  MBEDTLS_X509_CRT_PARSE_C
#undef  MBEDTLS_X509_CRL_PARSE_C

/* Save RAM at the expense of ROM */
#define MBEDTLS_AES_ROM_TABLES

/* Save RAM by adjusting to our exact needs */
#define MBEDTLS_ECP_MAX_BITS   256
#define MBEDTLS_MPI_MAX_SIZE    32

/* Save RAM at the expense of speed, see ecp.h */
#define MBEDTLS_ECP_WINDOW_SIZE        2
#define MBEDTLS_ECP_FIXED_POINT_OPTIM  0

/* Significant speed benefit at the expense of some ROM */
#define MBEDTLS_ECP_NIST_OPTIM
/*
* You should adjust this to the exact number of sources you're using: default
* is the "mbedtls_platform_entropy_poll" source, but you may want to add other ones.
* Minimum is 2 for the entropy test suite.
*/
#define MBEDTLS_ENTROPY_MAX_SOURCES 2
#define MBEDTLS_NO_PLATFORM_ENTROPY

#endif /* MBEDTLS_EDDYSTONE_CONFIG_H */
